#ifndef CONTROL_INC
#define CONTROL_INC

//
// User Control and AI.
// Copyright (c) 1999 by B.Pickhardt (pickhardt@debitel.net).
// aka hackCraft
//

class cControler;
class cAI;
class cEntity;
class cVector;

#include "math3d.h"

#include <string>
using namespace std;


class cController {
  public:
  cEntity* mDevice; // what we control

  cVector mChasis; // movement wishes
  cVector mTower;
  float mThrottle;
  
  int mWeapon; // current selected weapon

  public:
	cController();
  virtual void processSelf();
  void transferSelf();
};

#include <stack>
using namespace std;

class cAI : public cController {
  struct state_struct {
    int state;
    string entity_name;
    cEntity* entity;
  };
  public:
  enum { WAIT, ENGAGE, TARGET, ATTACK, FOLLOW, FLEE, ROUTE, PATROL };
  public:
  cVector mSelf;
  cVector mDest;
  int mNav;
  float mDisturb;
  float mThreshold;
  stack<state_struct*> mState;
  public:
  cAI();

  void processSelf();

  void clearState();
  void overideState(int state, cEntity* entity);
  void overideState(int state, char* entityname);
  void newState(int state, cEntity* entity);
  void newState(int state, char* entityname);
  void oldState();

  void waitEnemy();
  void engageEnemy();
  void targetEnemy();
  void attackEnemy();
  void followLeader();
  void fleeEnemy();
  void routeNav();
  void patrolArea();
};


#endif

