#ifndef ENTITIES_H
#define ENTITIES_H


#include "objects.h"

class cEntity;
//  class cNavSequence;
  class cGeospot;
  class cWeapon;
  class cProjectile;
  class cBuilding;
  class cTree;
  class cMech;
  class cTank;


//-----------------------------------

/*	
class cNavSequence : public cEntity {
	public:
	struct geospot { string designation; string description; float pos[3]; };
	list<geospot*> spots;
  public:
  virtual char* getClass() { return "cNavSequence"; };
  virtual cObject* newSelf() { return new cNavSequence; };
};
*/

class cGeospot : public cEntity {
// These may be used to make so called Navpoints.
// Just place an instance of this entity for one Navpoint.
// The names of several Geospots may be the same: That is the navsequence domain it belongs to.
// Controllers may make an object call to collect all Geospots belonging together - to one domain.
// The individual Geospots within one domain differ in their sequence numbers.
// Geospot provides functionality to translate this sequence letter to a human (or bot) readable
// designation: 'a' to 'z' to NATO-Alphabet (which is different to greek: "Alpha", "Beta", "Gamma").
  protected:
	unsigned int mDesignation; // { 0, .., 26 } (, not { a, ..., z }).

	public:
  cGeospot(float* pos = NULL, float* rot = NULL, char* domain_name = NULL, unsigned int des = 0);
  virtual char* getClass() { return "cGeospot"; };
  virtual cObject* newSelf() { return new cGeospot; };

	void setDesignation(unsigned int des) {	mDesignation = des % 26; };
	unsigned int getDesignation() { return mDesignation; };

	const char* translateDesignation(unsigned int des);
};


class cWeapon : public cEntity {
  public:
  float* mBasefv;
  float* mMountfv;
  float mSource[16];
  int mNAmmo;
  cProjectile* mTAmmo;         // Type of Ammo
  DWORD mTime;          // mTime <= clock()   ==   ready
  float mHeat;

  public:
  cWeapon();
  virtual char* getClass() { return "cWeapon"; };
  virtual cObject* newSelf() { return new cWeapon; };

  void onSpawn();

  void copySelf(cWeapon *source);
  void fireSelf(cObject *target);
};

/*
class cProjectile : public cEntity {
  protected:
  float              mMatrix[16];
  public:
  bool               mGuided;
  cObject           *mTarget;
  bool               mDestroyed;
  float              mFlown;
  cVector            mDirection;
  float              mSpeed;

  public:
                     cProjectile(float* pos = NULL, float* rot = NULL);
  virtual char*      getClass() { return "cProjectile"; };
  virtual cObject*   newSelf() { return new cProjectile; };

  void               onSpawn();

  void               Fly(float spf);
  void               animateSelf(float spf);

  bool               scanSphere(cSphere sphere);
};
*/


class cBuilding : public cEntity {
  public:
  cBuilding(float* pos = NULL, float* rot = NULL);
  virtual char* getClass() { return "cBuilding"; };
  virtual cObject* newSelf() { return new cBuilding; };

  void onSpawn();
};


class cTree : public cEntity {
	protected:
  string desc;
  public:
  cTree(float* pos = NULL, float* rot = NULL, char* descriptor = NULL);
  virtual char* getClass() { return "cTree"; };
  virtual cObject* newSelf() { return new cTree; };

  void onSpawn();
};


class cMech : public cEntity {
  public:
  enum {
	  Zero,Hips, CTorsor, LTorsor, RTorsor, Head,
    LUpLeg, RUpLeg, LLoLeg, RLoLeg, LFoot, RFoot,
	  LUpArm, RUpArm, LLoArm, RLoArm, MAX_MECH_PARTS
	};

  protected:
  float mTimer;
  list<cWeapon *> mWeapons;
  cVector mTwr;
  float mJetOn;
  float mSpeed;

  float mMatrix[16];
  float (*mRotators)[3];
  float mPilot[16];

  public:
	cMech(float* pos = NULL, float* rot = NULL);
  virtual char* getClass() { return "cMech"; };
  virtual cObject* newSelf() { return new cMech; };

  void onSpawn();

  float* getPilotMatrix();
  void Pattern(float t, char *pattern);
  void Walk(float spf);

  void ChasisLR(float r);
  void ChasisUD(float r);
  void TowerLR(float r);
  void TowerUD(float r);
  void Throttle(float percent);
  void Jet(float percent);

  void fireAllWeapons(cObject *target);
  void fireWeapon(int n, cObject *target);
  void mountWeapon(char* point, cWeapon *weapon);

  void animateSelf(float spf);

  int handleMsg(int msg, long prma, long prmb, long prmc);
};


class cTank : public cEntity {
  public:
  enum { Zero,Chasis, LChain, RChain, Turret, Weapon };
  public:
  virtual char* getClass() { return "cTank"; };
  virtual cObject* newSelf() { return new cTank; };
};



#endif
